// BkDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "BkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ca_ModeDiff			0x02
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDlg dialog
CBkDlg::CBkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBkDlg)
	m_s1 = _T("");
	m_fU = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBkDlg)
	DDX_Control(pDX, IDDLL, m_btnDll);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDLIRE, m_btnLire);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_U, m_fU);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBkDlg, CDialog)
	//{{AFX_MSG_MAP(CBkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDLIRE, OnLire)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDDLL, OnDll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDlg message handlers

BOOL CBkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_s1="";
	BOOL ok=FALSE;
	//La zone de texte ne sert qu' l'affichage...
	GetDlgItem(IDC_U)->EnableWindow(FALSE);
	m_hDLL=LoadLibrary("SysamPci.dll");
	if (m_hDLL!=NULL)
	{
		ok=TRUE;m_iNb=0;
		SystemePresent=(SYSTEMEPRESENT*)GetProcAddress(m_hDLL,"SystemePresent");
		if (SystemePresent==NULL)
		{ 
			ok=FALSE;m_iNb++;
		}
		ProgrammerEtatSysteme=(PROGRAMMERETATSYSTEME*)GetProcAddress(m_hDLL,"ProgrammerEtatSysteme");
		if (ProgrammerEtatSysteme==NULL)
		{ 
			ok=FALSE;m_iNb++;
		}
		//BYTE = unsigned char
		//double = flottant double prcision
		LireEA_Reel=(LIREEA_REEL*)GetProcAddress(m_hDLL,"LireEA_Reel");
		if (LireEA_Reel==NULL)
		{ 
			ok=FALSE;m_iNb++;
		}
		EcrireSA_Reel=(ECRIRESA_REEL*)GetProcAddress(m_hDLL,"EcrireSA_Reel");
		if (EcrireSA_Reel==NULL)
		{ 
			ok=FALSE;m_iNb++;
		}
		EcrireCalibreEA=(ECRIRECALIBREEA*)GetProcAddress(m_hDLL,"EcrireCalibreEA");
		if (EcrireCalibreEA==NULL)
		{ 
			ok=FALSE;m_iNb++;
		}
		if (!ok)
		{
			m_s1.Format("%d fonction(s) non trouve(s) dans SysamPCI.dll !",m_iNb);
			m_btnLire.EnableWindow(FALSE);
		}
	}
	else
	{
		m_s1.Format("Librairie SysamPCI.dll non trouve !");
		ok=FALSE;
		m_btnLire.EnableWindow(FALSE);
	}
	if (ok)
	{
		unsigned char c=SystemePresent();
		/*
		if (c==0)
		{
			m_s1.Format("Carte Sysam PCI non trouve !\n(SystemePresent=%d)",c);
			m_btnLire.EnableWindow(FALSE);
		}
		else
		*/
		{
			//ProgrammerEtatSysteme(ca_ModeDiff,FALSE);
			ProgrammerEtatSysteme(0x2,FALSE);
			float u=LireEA_Reel(0,1);
			if (u<9.9999 && u>-9.9999)
			{
				m_s1.Format("Carte Sysam PCI OK...\n(LireEA_Reel(0,1)=%1.3f)",u);
			}
			else
			{
				m_s1.Format("Carte Sysam PCI non trouve !\n(LireEA_Reel(0,1) hors limites...)");
				m_btnLire.EnableWindow(FALSE);
			}
		}
	}
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CBkDlg::OnLire() 
{
	if (m_OK==FALSE)
	{
		//Lire
		m_btnLire.SetWindowText("&Arrter");
		m_btnCancel.EnableWindow(FALSE);
		m_btnDll.EnableWindow(FALSE);
		m_iNb=0;

		short Voie=0,Gain=1;//Gain sur la voie: 1, 2, 4 ou 10
		EcrireCalibreEA(Voie,Gain);

		m_OKBusy=FALSE;SetTimer(1,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(1);
		m_btnCancel.EnableWindow(TRUE);
		m_btnDll.EnableWindow(TRUE);
		m_btnLire.SetWindowText("&Lire");
		m_s1.Format("Arrt conversion A/N demande...");
		UpdateData(FALSE);	
	}
	m_OK=!m_OK;
}
//________________________________________
void CBkDlg::OnTimer(UINT nIDEvent) 
{
	short Voie=0;//N de voie A/N, 0  7
	float u,r;
	short i,n;
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		r=0;
		n=0;
		//Moyennage sur 10 valeurs
		for (i=0;i<10;i++)
		{
			u=LireEA_Reel(Voie,1);
			if (u<11.0 && u>-11.0)
			{
				r=r+u;
				n++;
			}
		}
		if (n>0) r=r/n; else r=1e10;

		m_fU=r;
		m_iNb++;
		m_s1.Format("Conversion A/N en cours... (%d)",m_iNb);
		UpdateData(FALSE);	
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CBkDlg::OnCancel() 
{
	BOOL ok;
	if (m_hDLL!=NULL)
	{
		ok=FreeLibrary(m_hDLL);
		if (ok)
		{
			m_s1.Format("SysamPci.dll libr...");
			UpdateData(FALSE);	
			Sleep(400);
			//AfxMessageBox("SysamPci.dll libr...");
		}
	}
	CDialog::OnCancel();
}
//________________________________________
void CBkDlg::OnDll() 
{
	AfxMessageBox("//PROTOTYPES DES FONCTIONS DE LA DLL\n\nint AcquerirTable(PtrTableVal,int*);\ndouble BinVoltEA(int,int);\ndouble BinVoltSA(int,int);\nBOOL Declencher(void);\nvoid DevaliderTimer(void);\nvoid EcrireBit(BYTE,BYTE,BOOL);\nvoid EcrireCalibreEA(BYTE,BYTE);\nvoid EcrireCalibreSA(int,int);\nvoid EcrireGain(BYTE,BYTE);\nvoid EcrirePort(BYTE,BYTE);\nvoid EcrireSA_Entier(BYTE,int);\nvoid EcrireSA_Reel(BYTE,double);\nvoid EcrireTempo(int);\nvoid EmettreSorties(PtrTableVal);\nvoid FermetureDLL(void);\nvoid LimitesCalibreEA(BYTE,BYTE,double*,double*);\nvoid LimitesCalibreSA(BYTE,BYTE,double*,double*);\nBYTE LireBit(BYTE,BYTE);\nBYTE LireCalibreEA(BYTE);\nBYTE LireCalibreSA(BYTE);\n ? LireDureeMinimale (?) //non dfini !\nint LireEA_Entier(BYTE,BYTE);\ndouble LireEA_Reel(BYTE,BYTE);\nWORD LireGain(BYTE);\nchar* LireInfos(int,int,int);\nBYTE LirePort(BYTE);\nBYTE LireSensPort(BYTE);\nint LireTempo(void);\nBYTE LireTimer(void);\nBOOL OkEtatSysteme(WORD);\nvoid PreparerAcquisition(int,int,double,PtrTableVoie,TypeProcTache);//TypeProcTache non dfini !\nvoid PreparerEmission(int,int,int,PtrTableVoie,TypeProcTache);//TypeProcTache non dfini !\n? ProgrammerAccesRapide(?);//non dfini\nvoid ProgrammerDeclenchement(BYTE,double,BYTE);\nvoid ProgrammerEtatSysteme(int,BOOL);\nBOOL ProgrammerSensPort(BYTE,BYTE);\n? ProgrammerSortieVoieEnAcquis(?);//non dfini\nvoid ProgrammerTimer(int);\nPtrSysteme RenvoyerSysteme(void);\nBOOL SystemePresent(void);\nvoid ValiderTimer(void);\nint VoltBinEA(double,int);\nint VoltBinSA(double,int);");	
}
//________________________________________
void CBkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
//________________________________________
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
//________________________________________
void CBkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//________________________________________
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
