// BkDlg.h : header file
//________________________________________
// CBkDlg dialog
class CBkDlg : public CDialog
{
// Construction
public:
	CBkDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CBkDlg)
	enum { IDD = IDD_BK_DIALOG };
	CButton	m_btnDll;
	CButton	m_btnCancel;
	CButton	m_btnLire;
	CString	m_s1;
	float	m_fU;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	BOOL m_OK,m_OKBusy;
	short m_iNb;

	HINSTANCE m_hDLL;
	typedef BOOL (CALLBACK  SYSTEMEPRESENT)(void);
	typedef void (CALLBACK PROGRAMMERETATSYSTEME)(int,BOOL);
	typedef double (CALLBACK LIREEA_REEL)(BYTE,BYTE);
	typedef void (CALLBACK ECRIRESA_REEL)(BYTE,double);
	typedef void (CALLBACK ECRIRECALIBREEA)(BYTE,BYTE);

	SYSTEMEPRESENT* SystemePresent;
	PROGRAMMERETATSYSTEME* ProgrammerEtatSysteme;
	LIREEA_REEL* LireEA_Reel;
	ECRIRESA_REEL* EcrireSA_Reel;
	ECRIRECALIBREEA* EcrireCalibreEA;


	// Generated message map functions
	//{{AFX_MSG(CBkDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	afx_msg void OnLire();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDll();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
